/******************** (C) COPYRIGHT 2011 STMicroelectronics ********************
* File Name          : platform_config.h
* Author             : MCD Application Team
* Version            : V3.3.0
* Date               : 21-March-2011
* Description        : Evaluation board specific configuration file.
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __PLATFORM_CONFIG_H
#define __PLATFORM_CONFIG_H

/* Includes ------------------------------------------------------------------*/

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Uncomment the line corresponding to the STMicroelectronics evaluation board
   used to run the example */
#if !defined (USE_STM3210B_EVAL) &&  !defined (USE_STM3210E_EVAL)  &&  !defined (USE_STM3210C_EVAL)  &&  !defined (USE_STM32L152_EVAL)
 #define USE_STM3210B_EVAL
 //#define USE_STM3210E_EVAL
 //#define USE_STM3210C_EVAL
 //#define USE_STM32L152_EVAL
#endif


/* Define the STM32F10x hardware depending on the used evaluation board */
#ifdef USE_STM3210B_EVAL
//  /* USB */
//  #define USB_DISCONNECT                	GPIOA  				
//  #define USB_DISCONNECT_PIN            	GPIO_Pin_14
//  #define RCC_APB2Periph_GPIO_DISCONNECT 	RCC_APB2Periph_GPIOA
  /* Output OE */
  #define JTAG_OE_GPIO						GPIOA
  #define JTAG_OE_GPIO_CLK          		RCC_APB2Periph_GPIOA
  #define JTAG_OE							GPIO_Pin_8
  /* SPI1 */
  #define SPI_MASTER                   		SPI1
  #define SPI_MASTER_CLK               		RCC_APB2Periph_SPI1
  #define SPI_MASTER_GPIO              		GPIOA
  #define SPI_MASTER_GPIO_CLK          		RCC_APB2Periph_GPIOA  
  #define SPI_MASTER_PIN_SCK           		GPIO_Pin_5
  #define SPI_MASTER_PIN_MISO          	 	GPIO_Pin_6
  #define SPI_MASTER_PIN_MOSI          		GPIO_Pin_7
  /* SPI2 */
  #define SPI_SLAVE							SPI2
  #define SPI_SLAVE_CLK						RCC_APB1Periph_SPI2
  #define SPI_SLAVE_GPIO					GPIOB
  #define SPI_SLAVE_GPIO_CLK				RCC_APB2Periph_GPIOB 
  #define SPI_SLAVE_PIN_SCK					GPIO_Pin_13
  #define SPI_SLAVE_PIN_MISO				GPIO_Pin_14
  #define SPI_SLAVE_PIN_MOSI				GPIO_Pin_15
  /* USART2 */
  #define USART_MASTER                   	USART2
  #define USART_MASTER_GPIO              	GPIOA
  #define USART_MASTER_CLK               	RCC_APB1Periph_USART2
  #define USART_MASTER_GPIO_CLK          	RCC_APB2Periph_GPIOA
  #define USART_MASTER_TxPin             	GPIO_Pin_2
  #define USART_MASTER_ClkPin            	GPIO_Pin_4
  /* USART1 */
  #define UART1              				USART1
  #define UART1_GPIO              			GPIOA
  #define UART1_CLK               			RCC_APB2Periph_USART1
  #define UART1_GPIO_CLK          			RCC_APB2Periph_GPIOA
  #define UART1_TxPin             			GPIO_Pin_9
  #define UART1_RxPin            			GPIO_Pin_10
  /* USART3 */
  #define UART3              				USART3
  #define UART3_GPIO              			GPIOB
  #define UART3_CLK               			RCC_APB1Periph_USART2
  #define UART3_GPIO_CLK          			RCC_APB2Periph_GPIOB
  #define UART3_TxPin						GPIO_Pin_10
  #define UART3_RxPin            			GPIO_Pin_11
  /* communication LED */
  #define TIM2_GPIO							GPIOA
  #define TIM2_GPIO_CLK						RCC_APB2Periph_GPIOA
  #define TIM2_CLK							RCC_APB1Periph_TIM2
  #define TIM2_CH1_USB 						GPIO_Pin_0
  #define TIM2_CH2_JTAG 					GPIO_Pin_1
  /* LED */
  #define LED_GPIOA							GPIOA
  #define LED_GPIOA_CLK						RCC_APB2Periph_GPIOA
  #define LED1_PA3							GPIO_Pin_3
  #define LED_GPIOB							GPIOB
  #define LED_GPIOB_CLK						RCC_APB2Periph_GPIOB
  #define LED2_PB0							GPIO_Pin_0
  #define LED3_PB1							GPIO_Pin_1
  #define LED4_PB12							GPIO_Pin_12
  /* SW */
  #define SW_GPIO							GPIOB
  #define SW_GPIO_CLK						RCC_APB2Periph_GPIOB
  #define SW1_PB6							GPIO_Pin_6
  #define SW2_PB7							GPIO_Pin_7
  #define SW3_PB8							GPIO_Pin_8
  #define SW4_PB9							GPIO_Pin_9
  /* POWER Control */
  #define PWC_GPIO							GPIOB
  #define PWC_GPIO_CLK						RCC_APB2Periph_GPIOB
  #define PWC_BOOT1							GPIO_Pin_2
  /* JTAG Pin */
  #define JTAG_GPIOA_CLK					RCC_APB2Periph_GPIOA
  #define JTAG_TCK							GPIO_Pin_5
  #define JTAG_TMS							GPIO_Pin_2
  #define JTAG_GPIOB_CLK					RCC_APB2Periph_GPIOB
  #define JTAG_TDO							GPIO_Pin_15
  #define JTAG_TDI							GPIO_Pin_14

  #define RCC_APB2Periph_ALLGPIO             (RCC_APB2Periph_GPIOA \
                                              | RCC_APB2Periph_GPIOB \
                                              | RCC_APB2Periph_GPIOC \
                                              | RCC_APB2Periph_GPIOD \
                                              | RCC_APB2Periph_GPIOE \
                                              | RCC_APB2Periph_GPIOF \
                                              | RCC_APB2Periph_GPIOG )

#elif defined (USE_STM3210E_EVAL)
  #define USB_DISCONNECT                      GPIOB  
  #define USB_DISCONNECT_PIN                  GPIO_Pin_14
  #define RCC_APB2Periph_GPIO_DISCONNECT      RCC_APB2Periph_GPIOB
                                                
  #define RCC_APB2Periph_ALLGPIO             (RCC_APB2Periph_GPIOA \
                                              | RCC_APB2Periph_GPIOB \
                                              | RCC_APB2Periph_GPIOC \
                                              | RCC_APB2Periph_GPIOD \
                                              | RCC_APB2Periph_GPIOE \
                                              | RCC_APB2Periph_GPIOF \
                                              | RCC_APB2Periph_GPIOG )

//#elif defined (USE_STM3210C_EVAL)
//  /* USB_Disconnect pin not used */
//  #define USB_DISCONNECT                      0  
//  #define USB_DISCONNECT_PIN                  0
//  #define RCC_APB2Periph_GPIO_DISCONNECT      0
//
//  #define GPIO_Pin_UP                         GPIO_Pin_15  /* PG.15 */
//  #define GPIO_Pin_DOWN                       GPIO_Pin_3   /* PD.03 */
//  #define GPIO_Pin_LEFT                       GPIO_Pin_14  /* PG.14 */
//  #define GPIO_Pin_RIGHT                      GPIO_Pin_13  /* PG.13 */    
//
//  #define RCC_APB2Periph_ALLGPIO             (RCC_APB2Periph_GPIOA \
//                                              | RCC_APB2Periph_GPIOB \
//                                              | RCC_APB2Periph_GPIOC \
//                                              | RCC_APB2Periph_GPIOD \
//                                              | RCC_APB2Periph_GPIOE \
//                                              | RCC_APB2Periph_GPIOF \
//                                              | RCC_APB2Periph_GPIOG )

#elif defined (USE_STM32L152_EVAL)

 /* 
   For STM32L15xx devices it is possible to use the internal USB pullup
   controlled by register SYSCFG_PMC (refer to RM0038 reference manual for
   more details).
   It is also possible to use external pullup (and disable the internal pullup)
   by setting the define USB_USE_EXTERNAL_PULLUP in file platform_config.h
   and configuring the right pin to be used for the external pull up configuration.
   To have more details on how to use an external pull up, please refer to 
   STM3210E-EVAL evaluation board manuals.
   */
 /* Uncomment the following define to use an external pull up instead of the 
    integrated STM32L15xx internal pull up. In this case make sure to set up
    correctly the external required hardware and the GPIO defines below.*/
/* #define USB_USE_EXTERNAL_PULLUP */

 #if !defined(USB_USE_EXTERNAL_PULLUP)
  #define STM32L15_USB_CONNECT                SYSCFG_USBPuCmd(ENABLE)
  #define STM32L15_USB_DISCONNECT             SYSCFG_USBPuCmd(DISABLE)

 #elif defined(USB_USE_EXTERNAL_PULLUP)
  /* PA0 is chosen just as illustrating example, you should modify the defines
    below according to your hardware configuration. */
  #define USB_DISCONNECT                      GPIOA
  #define USB_DISCONNECT_PIN                  GPIO_Pin_0
  #define RCC_AHBPeriph_GPIO_DISCONNECT       RCC_AHBPeriph_GPIOA
  #define STM32L15_USB_CONNECT                GPIO_ResetBits(USB_DISCONNECT, USB_DISCONNECT_PIN)
  #define STM32L15_USB_DISCONNECT             GPIO_SetBits(USB_DISCONNECT, USB_DISCONNECT_PIN)
 #endif /* USB_USE_EXTERNAL_PULLUP */
                                                
  #define RCC_AHBPeriph_ALLGPIO              (RCC_AHBPeriph_GPIOA \
                                              | RCC_AHBPeriph_GPIOB \
                                              | RCC_AHBPeriph_GPIOC \
                                              | RCC_AHBPeriph_GPIOD \
                                              | RCC_AHBPeriph_GPIOE \
                                              | RCC_AHBPeriph_GPIOH)

#endif /* USE_STM3210B_EVAL */

/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

#endif /* __PLATFORM_CONFIG_H */

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/

