/******************** (C) COPYRIGHT 2011 STMicroelectronics ********************
* File Name          : usb_prop.h
* Author             : MCD Application Team
* Version            : V3.3.0
* Date               : 21-March-2011
* Description        : All processing related to Virtual COM Port Demo (Endpoint 0)
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __usb_prop_H
#define __usb_prop_H

/* Includes ------------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/

#define JUPOD_GetConfiguration          NOP_Process
//#define JUPOD_SetConfiguration          NOP_Process
#define JUPOD_GetInterface              NOP_Process
#define JUPOD_SetInterface              NOP_Process
#define JUPOD_GetStatus                 NOP_Process
#define JUPOD_ClearFeature              NOP_Process
#define JUPOD_SetEndPointFeature        NOP_Process
#define JUPOD_SetDeviceFeature          NOP_Process
//#define JUPOD_SetDeviceAddress          NOP_Process

#define SEND_ENCAPSULATED_COMMAND   0x00
#define GET_ENCAPSULATED_RESPONSE   0x01
#define SET_COMM_FEATURE            0x02
#define GET_COMM_FEATURE            0x03
#define CLEAR_COMM_FEATURE          0x04
#define SET_LINE_CODING             0x20
#define GET_LINE_CODING             0x21
#define SET_CONTROL_LINE_STATE      0x22
#define SEND_BREAK                  0x23

/* Exported functions ------------------------------------------------------- */
void JUPOD_init(void);
void JUPOD_Reset(void);
void JUPOD_SetConfiguration(void);
void JUPOD_SetDeviceAddress(void);
void JUPOD_Status_In(void);
void JUPOD_Status_Out(void);
RESULT JUPOD_Data_Setup(uint8_t);
RESULT JUPOD_NoData_Setup(uint8_t);
RESULT JUPOD_Get_Interface_Setting(uint8_t Interface, uint8_t AlternateSetting);
uint8_t *JUPOD_GetDeviceDescriptor(uint16_t);
uint8_t *JUPOD_GetConfigDescriptor(uint16_t);
uint8_t *JUPOD_GetStringDescriptor(uint16_t);

#endif /* __usb_prop_H */

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/

