/******************** (C) COPYRIGHT 2011 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Version            : V3.3.0
* Date               : 21-March-2011
* Description        : Joystick Mouse demo main file
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#ifdef STM32L1XX_MD
#include "stm32l1xx.h"
#else
#include "stm32f10x.h"
#endif /* STM32L1XX_MD */

#include "usb_lib.h"
#include "hw_config.h"
#include "usb_pwr.h"
#include "platform_config.h"

#include "data_define.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
__IO uint8_t PrevXferComplete = 1;

uint16_t 	next_Data_Process_ADDR;

uint8_t 	flag;	//ãжϳǷִ

/* Extern variables ----------------------------------------------------------*/
uint8_t 	EP1_TX_Buffer[64];
uint8_t 	EP1_RX_Buffer[64];

uint8_t 	EP1_TX_Count;
uint8_t 	EP1_RX_Count;
uint8_t 	EP3_RX_Count;
uint8_t 	EP2_TX_Count;

uint8_t 	USB_RX_Buffer[512];
uint8_t 	USB_TX_Buffer[512];
uint8_t		*USB_RX_Buffer_ADDR;
uint8_t		*USB_TX_Buffer_ADDR;
uint16_t 	USB_TX_Count_Buf;

uint16_t 	USB_RX_Count;
uint8_t 	USB_RX_Done;
uint8_t 	USB_TX_Done;

uint16_t 	SPI_Data_Count;  //ҲʾUSB_TX_Count

uint8_t 	SPI_RX_Buffer[512];
uint8_t 	SPI_TX_Buffer[512];

uint8_t 	Data_Process;
uint16_t	Data_Process_ADDR;

uint8_t 	instructionTMS[6];

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
uint16_t instruction_analyze(uint8_t instruction,uint16_t ilocation);
void data_init(void);
void IO_PINS_init(void);
void USB_transmit(void);
void TIM2_Configuration(void);

/*******************************************************************************
* Function Name  : main.
* Description    : main routine.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
int main(void)
{
	Set_System();
  
	USB_Interrupts_Config();
  
	Set_USBClock();
  
	USB_Init();

	SetEPTxValid(ENDP2);
	SetEPRxValid(ENDP3);

	data_init();

	while(1)
	{
		//
		if(GPIO_ReadInputDataBit(SW_GPIO, SW1_PB6))
		{
			GPIO_WriteBit(LED_GPIOB, LED2_PB0, (BitAction)(0));
			//һǷ
			while(GetEPTxStatus(ENDP2)==EP_TX_VALID)
				break;
			UserToPMABufferCopy(USB_RX_Buffer, ENDP2_TXADDR, 1);
      		SetEPTxCount(ENDP2, 1);
      		SetEPTxValid(ENDP2);
		}
		else
		{
			GPIO_WriteBit(LED_GPIOB, LED2_PB0, (BitAction)(1));
		}
	}
}
/*******************************************************************************
* Function Name  : data_init.
* Description    : ̶ݼݳʼ.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void data_init(void)
{
	//ݳʼ
	USB_RX_Buffer[0] = 0x00;
	USB_RX_Buffer[1] = 0x02;
	USB_RX_Buffer[2] = 0x05;
	USB_RX_Buffer[3] = 0x04;
	USB_RX_Buffer[4] = 0x0A;
	USB_RX_Buffer[5] = 0x03;

	USB_RX_Buffer[6] = 0x01;
	USB_RX_Buffer[7] = 0x04;
	USB_RX_Buffer[8] = 0x05;
	USB_RX_Buffer[9] = 0x03;
	USB_RX_Buffer[10] = 0x30;
	USB_RX_Buffer[11] = 0x56;
	USB_RX_Buffer[12] = 0x64;
	USB_RX_Buffer[13] = 0xff;
	USB_RX_Buffer[14] = 0x05;
	USB_RX_Buffer[15] = 0x08;
	USB_RX_Buffer[16] = 0xff;
	USB_RX_Buffer[17] = 0x03;

	USB_RX_Buffer[18] = 0x02;
	USB_RX_Buffer[19] = 0x05;
	USB_RX_Buffer[20] = 0x04;
	USB_RX_Buffer[21] = 0x07;
	USB_RX_Buffer[22] = 0x03;
}
#ifdef  USE_FULL_ASSERT
/*******************************************************************************
* Function Name  : assert_failed
* Description    : Reports the name of the source file and the source line number
*                  where the assert_param error has occurred.
* Input          : - file: pointer to the source file name
*                  - line: assert_param error line source number
* Output         : None
* Return         : None
*******************************************************************************/
void assert_failed(uint8_t* file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {}
}
#endif

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
