/******************** (C) COPYRIGHT 2011 STMicroelectronics ********************
* File Name          : usb_endp.c
* Author             : MCD Application Team
* Version            : V3.3.0
* Date               : 21-March-2011
* Description        : Endpoint routines
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "usb_lib.h"
#include "usb_desc.h"
#include "usb_mem.h"
#include "hw_config.h"
#include "usb_istr.h"
#include "usb_pwr.h"
#include "data_define.h"
#include "platform_config.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Interval between sending IN packets in frame number (1 frame = 1ms) */
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/*******************************************************************************
* Function Name  : EP2_IN_Callback.
* Description    : EP2 IN Callback Routine.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP2_IN_Callback(void)
{	  
}
/*******************************************************************************
* Function Name  : EP3_OUT_Callback.
* Description    : EP3 OUT Callback Routine.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP3_OUT_Callback(void)
{
	uint8_t EP3_RX_Buffer[64];

	EP3_RX_Count = GetEPRxCount(ENDP3);

	//
	GPIO_WriteBit(LED_GPIOB, LED4_PB12, (BitAction)(0));

	if(USB_RX_Buffer_ADDR >= &USB_RX_Buffer[Data_Process_ADDR])
	{
		if(USB_RX_Buffer_ADDR + EP3_RX_Count < &USB_RX_Buffer[511])
		{
			PMAToUserBufferCopy(USB_RX_Buffer_ADDR, GetEPRxAddr(ENDP3), EP3_RX_Count);
			USB_RX_Buffer_ADDR = USB_RX_Buffer_ADDR + EP3_RX_Count;
		}
		else if(USB_RX_Buffer_ADDR + EP3_RX_Count == &USB_RX_Buffer[511])
		{
			PMAToUserBufferCopy(USB_RX_Buffer_ADDR, GetEPRxAddr(ENDP3), EP3_RX_Count);
			USB_RX_Buffer_ADDR = USB_RX_Buffer;
		}
		else
		{
			PMAToUserBufferCopy(EP3_RX_Buffer, GetEPRxAddr(ENDP3), EP3_RX_Count);
			strncpy((char *)USB_RX_Buffer_ADDR,(char *)EP3_RX_Buffer,&USB_RX_Buffer[511]-USB_RX_Buffer_ADDR);
			USB_RX_Buffer_ADDR = USB_RX_Buffer;
			
			//ֹݽܹ
			//while((USB_RX_Buffer_ADDR + EP3_RX_Count -(*USB_RX_Buffer[511]-USB_RX_Buffer_ADDR)) > SPI_TX_ADDR);
			
			strncpy((char *)USB_RX_Buffer_ADDR,(char *)(EP3_RX_Buffer +(&USB_RX_Buffer[511]-USB_RX_Buffer_ADDR)),EP3_RX_Count-(&USB_RX_Buffer[511]-USB_RX_Buffer_ADDR));
			USB_RX_Buffer_ADDR += EP3_RX_Count-(&USB_RX_Buffer[511]-USB_RX_Buffer_ADDR);
		}
	}
	else 
	{
		//while((USB_RX_Buffer_ADDR + EP3_RX_Count -(*USB_RX_Buffer[511]-USB_RX_Buffer_ADDR)) > SPI_TX_ADDR);
		PMAToUserBufferCopy(USB_RX_Buffer_ADDR, GetEPRxAddr(ENDP3), EP3_RX_Count);
		USB_RX_Buffer_ADDR = USB_RX_Buffer_ADDR + EP3_RX_Count;
	} 

	SetEPRxValid(ENDP3);
}
/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/

